"use strict";
var core_1 = require('../core');
var FSInner = (function () {
    function FSInner(out, op) {
        this.out = out;
        this.op = op;
    }
    FSInner.prototype._n = function (t) {
        this.out._n(t);
    };
    FSInner.prototype._e = function (err) {
        this.out._e(err);
    };
    FSInner.prototype._c = function () {
        this.op.less();
    };
    return FSInner;
}());
var FlattenSeqOperator = (function () {
    function FlattenSeqOperator(ins) {
        this.ins = ins;
        this.open = true;
        this.active = false;
        this.seq = [];
        this.out = null;
    }
    FlattenSeqOperator.prototype._start = function (out) {
        this.out = out;
        this.ins._add(this);
    };
    FlattenSeqOperator.prototype._stop = function () {
        this.ins._remove(this);
        this.open = true;
        this.active = false;
        this.seq = [];
        this.out = null;
    };
    FlattenSeqOperator.prototype.less = function () {
        this.active = false;
        var seq = this.seq;
        if (seq.length > 0) {
            this._n(seq.shift());
        }
        if (!this.open && !this.active) {
            this.out._c();
        }
    };
    FlattenSeqOperator.prototype._n = function (s) {
        if (this.active) {
            this.seq.push(s);
        }
        else {
            this.active = true;
            s._add(new FSInner(this.out, this));
        }
    };
    FlattenSeqOperator.prototype._e = function (err) {
        this.out._e(err);
    };
    FlattenSeqOperator.prototype._c = function () {
        this.open = false;
        if (this.seq.length === 0) {
            this.out._c();
        }
    };
    return FlattenSeqOperator;
}());
exports.FlattenSeqOperator = FlattenSeqOperator;
function flattenSequentially() {
    return function flattenSequentiallyOperator(ins) {
        return new core_1.Stream(new FlattenSeqOperator(ins));
    };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = flattenSequentially;
//# sourceMappingURL=flattenSequentially.js.map